#version 330
#ifdef GL_ARB_shading_language_420pack
#extension GL_ARB_shading_language_420pack : require
#endif

uniform float aspect;
uniform vec4 player;
uniform float angle;
uniform float energy;
uniform bool clampDistance;
uniform float top;
uniform float bottom;
uniform vec2 lights[8];
uniform bool lightOn;
uniform sampler2D tex;
uniform int anim;
uniform float red;
uniform vec2 mouse;

in vec2 texCoord;
in vec4 color;
out vec4 FragColor;

float easeOutQuart(inout float t)
{
    float _216 = t;
    float _217 = _216 - 1.0;
    t = _217;
    return 1.0 - (((_217 * t) * t) * t);
}

float easeOutQuad(float t)
{
    return t * (2.0 - t);
}

vec2 hash(inout vec2 p)
{
    p = vec2(dot(p, vec2(127.09999847412109375, 311.70001220703125)), dot(p, vec2(269.5, 183.3000030517578125)));
    return vec2(-1.0) + (fract(sin(p) * 43758.546875) * 2.0);
}

float noise(vec2 p)
{
    vec2 i = floor(p + vec2((p.x + p.y) * 0.3660254180431365966796875));
    vec2 a = (p - i) + vec2((i.x + i.y) * 0.211324870586395263671875);
    vec2 o = step(a.yx, a);
    vec2 b = (a - o) + vec2(0.211324870586395263671875);
    vec2 c = (a - vec2(1.0)) + vec2(0.42264974117279052734375);
    vec3 h = max(vec3(0.5) - vec3(dot(a, a), dot(b, b), dot(c, c)), vec3(0.0));
    vec2 param = i + vec2(0.0);
    vec2 _130 = hash(param);
    vec2 param_1 = i + o;
    vec2 _137 = hash(param_1);
    vec2 param_2 = i + vec2(1.0);
    vec2 _144 = hash(param_2);
    vec3 n = (((h * h) * h) * h) * vec3(dot(a, _130), dot(b, _137), dot(c, _144));
    return dot(n, vec3(70.0));
}

float fractalNoise(inout vec2 uv)
{
    float f = 0.0;
    uv *= 5.0;
    mat2 m = mat2(vec2(1.60000002384185791015625, 1.2000000476837158203125), vec2(-1.2000000476837158203125, 1.60000002384185791015625));
    vec2 param = uv;
    f = 0.5 * noise(param);
    uv = m * uv;
    vec2 param_1 = uv;
    f += (0.25 * noise(param_1));
    uv = m * uv;
    vec2 param_2 = uv;
    f += (0.125 * noise(param_2));
    uv = m * uv;
    vec2 param_3 = uv;
    f += (0.0625 * noise(param_3));
    uv = m * uv;
    f = 0.5 + (0.5 * f);
    return f;
}

void main()
{
    float tx = ((texCoord.x * 2.0) - 1.0) * aspect;
    float ty = (texCoord.y * 2.0) - 1.0;
    tx = texCoord.x - player.x;
    ty = texCoord.y - player.y;
    float start = angle - 0.4000000059604644775390625;
    float end = angle + 0.4000000059604644775390625;
    float tangle = atan(texCoord.y - player.w, texCoord.x - player.z);
    float tdistance = sqrt((((tx * aspect) * tx) * aspect) + (((ty * 0.800000011920928955078125) * ty) * 0.800000011920928955078125));
    float scale = 1.0;
    float angledif = atan(cos(tangle - angle), sin(tangle - angle));
    scale *= (1.0 - clamp((abs(angledif) * 1.5) / energy, 0.0, 1.0));
    if (clampDistance)
    {
        float param = 1.0 - clamp(tdistance * 1.0, 0.0, 1.0);
        float _328 = easeOutQuart(param);
        scale *= _328;
    }
    bool _335 = texCoord.y < top;
    bool _344;
    if (!_335)
    {
        _344 = texCoord.y > bottom;
    }
    else
    {
        _344 = _335;
    }
    if (_344)
    {
        scale = 0.0;
    }
    float param_1 = clamp(scale, 0.0, 1.0);
    float _350 = easeOutQuart(param_1);
    scale = _350;
    float param_2 = 1.0 - clamp(tdistance * 5.0, 0.0, 1.0);
    float _356 = easeOutQuart(param_2);
    scale += _356;
    if (clampDistance)
    {
        for (int i = 0; i < 8; i++)
        {
            float difx = (texCoord.x - lights[i].x) * aspect;
            float dify = texCoord.y - lights[i].y;
            float dist = sqrt((difx * difx) + (dify * dify));
            float param_3 = 1.0 - clamp(dist * 7.5, 0.0, 1.0);
            scale += easeOutQuad(param_3);
        }
    }
    scale = clamp(scale, 0.0, 1.0);
    if (lightOn)
    {
        scale = 1.0;
    }
    vec4 texcolor = texture(tex, texCoord + vec2((sin((float(anim) / 20.0) + (texCoord.y * 8.0)) * 0.00999999977648258209228515625) * (1.0 - scale), 0.0)) * color;
    vec3 _457 = texcolor.xyz * color.w;
    texcolor = vec4(_457.x, _457.y, _457.z, texcolor.w);
    texcolor.x *= scale;
    texcolor.y *= scale;
    vec2 param_4 = texCoord - vec2(float(anim) / 500.0);
    float _478 = fractalNoise(param_4);
    vec2 param_5 = texCoord + vec2(float(anim) / 500.0);
    float _486 = fractalNoise(param_5);
    texcolor.z *= clamp(((_478 * _486) * 1.5) + scale, 0.0, 1.0);
    texcolor.x = max(texcolor.x, red);
    FragColor = texcolor;
}

